# HG changeset patch
# User Christophe Capon <christophe.capon@vilogia.fr>
# Date 1270092734 -7200
# Branch 5.3.0
# Node ID 9aaeeb2258c561b39452c81658948d090448f3b5
# Parent  30115d3f222047f114adb2bf6a9d2a27a987772e
Better session management

diff -r 30115d3f2220 -r 9aaeeb2258c5 nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/defer/DeferredNotificationHelper.java
--- a/nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/defer/DeferredNotificationHelper.java	Thu Apr 01 05:31:38 2010 +0200
+++ b/nuxeo-platform-notification-core/src/main/java/org/nuxeo/ecm/platform/ec/notification/defer/DeferredNotificationHelper.java	Thu Apr 01 05:32:14 2010 +0200
@@ -19,38 +19,26 @@
 
 package org.nuxeo.ecm.platform.ec.notification.defer;
 
-import java.io.StringReader;
-import java.io.StringWriter;
-import java.io.Writer;
 import java.util.ArrayList;
 import java.util.Collection;
-import java.util.Date;
 import java.util.List;
 import java.util.Map;
 
-import javax.mail.Message;
-import javax.mail.Session;
-import javax.mail.Transport;
-import javax.mail.internet.InternetAddress;
-import javax.mail.internet.MimeMessage;
-import javax.naming.InitialContext;
 import javax.security.auth.login.LoginContext;
 
 import org.apache.commons.logging.Log;
 import org.apache.commons.logging.LogFactory;
+import org.nuxeo.ecm.core.api.CoreInstance;
 import org.nuxeo.ecm.core.api.CoreSession;
 import org.nuxeo.ecm.core.api.DocumentModel;
 import org.nuxeo.ecm.deferredalert.DeferredAlertManagementService;
 import org.nuxeo.ecm.platform.ec.notification.NotificationConstants;
-import org.nuxeo.ecm.platform.ec.notification.service.NotificationService;
-import org.nuxeo.ecm.platform.ec.notification.service.NotificationServiceHelper;
 import org.nuxeo.ecm.platform.rendering.RenderingResult;
 import org.nuxeo.ecm.platform.rendering.RenderingService;
 import org.nuxeo.ecm.platform.rendering.impl.DocumentRenderingContext;
 import org.nuxeo.runtime.api.Framework;
 
 import freemarker.template.Configuration;
-import freemarker.template.Template;
 
 /**
  * Class EmailHelper.
@@ -108,6 +96,8 @@
         DocumentRenderingContext context = new DocumentRenderingContext();
         context.remove("doc");
         context.putAll(mail);
+        String sid = (String)mail.get("sessionId");
+        CoreSession coreSession = CoreInstance.getInstance().getSession(sid);
         context.setDocument((DocumentModel) mail.get("document"));
 
         rs.registerEngine(new DeferredNotificationsRenderingEngine(
@@ -125,9 +115,7 @@
         List<String> alerts = new ArrayList<String>();
         alerts.add(bodyMail);
 
-        CoreSession session = ((DocumentModel) mail.get("document")).getCoreSession();
-        
-        getService().storeAlerts(userPrincipal, alerts, session);
+        getService().storeAlerts(userPrincipal, alerts, coreSession);
 
         lc.logout();
 
